#ifdef HAVE_VIEWER
#include "Joystick.h"
#include "SDL.h"

/*!	\file Joystick.cpp
	\brief Implementation of Joystick controller
*/

namespace Teem
{
	JoystickController::JoystickController()
	{
		SDL_InitSubSystem(SDL_INIT_JOYSTICK);
			
		if(SDL_NumJoysticks()>0)
		{
			std::cout << "JoystickController: joystick found" << std::endl;
			joy = SDL_JoystickOpen(0);
		}
		else
		{
			std::cout << "!!! JoystickController: joystick not found" << std::endl;
			joy = NULL;
		}
	}
	
	JoystickController::~JoystickController()
	{
		if(SDL_JoystickOpened(0))
			SDL_JoystickClose(joy);
	}
	
	void JoystickController::step()
	{	
		SDL_JoystickUpdate();
		
		for(int i = 0; i < JOYSTICK_NB_BUTTONS; i++)
			output[i] = static_cast<double>(SDL_JoystickGetAxis(joy, i)) / 2000;
	}
	
	bool JoystickController::isButtonDown(unsigned button)
	{
		return SDL_JoystickGetButton(joy, button);
	}
}

#endif
