#ifdef HAVE_VIEWER
#include "Keyboard.h"
#include <SDL.h>

/*!	\file Keyboard.cpp
	\brief Implementation of the Keyboard Controller
*/

namespace Teem
{
	KeyboardController::KeyboardController(double runningSpeed, double turningSpeed)
	{
		this->runningSpeed = runningSpeed;
		this->turningSpeed = turningSpeed;
	}
	
	KeyboardController::~KeyboardController()
	{
		
	}
	
	void KeyboardController::step()
	{
		Uint8 *keystate = SDL_GetKeyState(NULL);
		output[0] = 0.0;	// left
		output[1] = 0.0;	// right
		if ( keystate[SDLK_DOWN] )
		{
			output[0] = -runningSpeed;
			output[1] = -runningSpeed;
		}
		if ( keystate[SDLK_UP] )
		{
			output[0] = runningSpeed;
			output[1] = runningSpeed;
		}
		if ( keystate[SDLK_LEFT] )
		{
			output[0] = -turningSpeed;
			output[1] = turningSpeed;
		}
		if ( keystate[SDLK_RIGHT] )
		{
			output[0] = turningSpeed;
			output[1] = -turningSpeed;
		}
		if ( keystate[SDLK_RIGHT] && keystate[SDLK_UP])
		{
			output[0] = runningSpeed;
			output[1] = runningSpeed * 0;
		}
		if ( keystate[SDLK_LEFT] && keystate[SDLK_UP])
		{
			output[0] = runningSpeed * 0;
			output[1] = runningSpeed;
		}
	}
}

#endif
